// ©CyberQ Consulting Pvt Ltd.

// Global InAppBrowser reference

// Polyfill for creating CustomEvents on IE9/10/11

// code pulled from:
// https://github.com/d4tocchini/customevent-polyfill
// https://developer.mozilla.org/en-US/docs/Web/API/CustomEvent#Polyfill

var storage=window.localStorage;

var IA_platform='AND'; // Platform

var IA_poplogin=false; // popup logon needed if TRUE

var IA_lrneng=false; // Android Student and Paid

var IA_hinglish=false;  // source he deleted if false
var IA_benglish=false;  // source be deleted if false

var BgStudId = storage.getItem("BgStudId");

if(BgStudId==undefined) {
  BgStudId='Anon' ;
  storage.setItem("BgStudId", BgStudId); 
}

today = new Date();
todaystr = today.toISOString().substr(0,7);

if(IA_poplogin) {
    if(storage.getItem("MaBhaTOD")==undefined) {
       storage.setItem("MaBhaTOD","1999-01");
       storage.setItem("MaBhaLSTAT","Not Logged In");
    }
}
else {
   storage.setItem("MaBhaTOD",todaystr);
   storage.setItem("MaBhaLSTAT","Validity 999 days");
}

try {
  new window.CustomEvent("test");
} catch(e) {
 var CustomEvent = function(event, params) {
      var evt;
      params = params || {
          bubbles: false,
          cancelable: false,
          detail: undefined
      };

      evt = document.createEvent("CustomEvent");
      evt.initCustomEvent(event, params.bubbles, params.cancelable, params.detail);
      return evt;
  };

  CustomEvent.prototype = window.Event.prototype;
  window.CustomEvent = CustomEvent; // expose definition to window
}

var iabRef = null;

var prvTime=0;
var nowTime=0;

var sixbmks = [];

var onech = "";
var myCode = "";
var myCodeInp = "";

prvTime = Date.now();

var prvUrl="xx";
var IA_addpage=true;

function sixinit() {
  sixbmks = [];
  for(var i=1;i<=6;i++) {
    onech=i.toString();
    sixbmks.push(storage.getItem("bmk" + onech));
  }
};

for (var i = 1; i <= 6; i++) {
    onech = i.toString();
    if (storage.getItem("bmk" + onech) == undefined)
        storage.setItem("bmk" + onech,'book mark ' + onech);
}
sixinit();

document.addEventListener('deviceready', onDeviceReady, false);

function onDeviceReady () {

    storage.setItem("StartMaBha","true");

    if(IA_platform=='WP8'){
      var url = new Windows.Foundation.Uri("ms-appx:///www/data/ipatranscc.js");
      Windows.Storage.StorageFile.getFileFromApplicationUriAsync(url).then(function (file) {
          Windows.Storage.FileIO.readTextAsync(file).then(function (text) {
              myCodeInp = text;
              // do something with object
          });
      });
    }
    else {
      var xmlHttp = new XMLHttpRequest();

      if(IA_lrneng)
         xmlHttp.open("GET", "js/ipatranscc.js", false);
      else
         xmlHttp.open("GET", "js/transcc.js", false);

      xmlHttp.send();
      myCodeInp = xmlHttp.responseText;
    }
}

    var app = angular.module('MaBhaApp', ['btford.modal']);
    
    // A new factory with an update method
    app.factory('MyService', function(){
      
        var MaBhaSrTg = storage.getItem("MaBhaSrTg");

        if(MaBhaSrTg==undefined) {
          if(IA_lrneng)
             MaBhaSrTg='EnHi';
          else
             MaBhaSrTg='HiEn';
          storage.setItem("MaBhaSrTg",MaBhaSrTg);
        }
       
        storage.setItem("FontPX","0");
        
        //storage.setItem("CurVer","1.2.9");

        var suborno = MaBhaSrTg.toLowerCase();
        
        var elang = {
            'hi' : 'Hindi' ,
            'mr' : 'Marathi' ,
            'bn' : 'Bengali' ,
            'as' : 'Assamese',
            'gr' : 'Gurmukhi' ,
            'gj' : 'Gujarati' ,
            'or' : 'Oriya' ,
            'tm' : 'Tamil' ,
            'tg' : 'Telugu' ,
            'kn' : 'Kannada' ,
            'ml' : 'Malayalam' ,
            'sh' : 'Sinhala' ,
            'ur' : 'Urdu' ,
            'en' : 'EnglishS',
            'ed' : 'EnglishD'
        };
        var vlang = {
            'hi' : 'हिन्दी' ,
            'mr' : 'माराठी' ,
            'bn' : 'বাংলা' ,
            'as' : 'অসমীয়া',
            'gr' : 'ਪੰਜਾਬੀ' ,
            'gj' : 'ગુજરાતી' ,
            'or' : 'ଓଡ଼ିଆ' ,
            'tm' : 'தமிழ்' ,
            'tg' : 'తెలుగు' ,
            'kn' : 'ಕನ್ನಡ' ,
            'ml' : 'മലയാളം' ,
            'sh' : 'සිංහල' ,
            'ur' : 'اردو' ,
            'en' : 'EnglishS',
            'ed' : 'EnglishD'
        };
        
        return {
            malekhmap: {
                map: suborno,
                esr: elang[suborno.substr(0,2)],
                vsr: vlang[suborno.substr(0,2)],
                etg: elang[suborno.substr(2,2)],
                vtg: vlang[suborno.substr(2,2)]
            },
            update: function(vmap) {
                // Improve this method as needed
                this.malekhmap.map = vmap;
                this.malekhmap.esr = elang[vmap.substr(0,2)];
                this.malekhmap.vsr = vlang[vmap.substr(0,2)];
                this.malekhmap.etg = elang[vmap.substr(2,2)];
                this.malekhmap.vtg = vlang[vmap.substr(2,2)];
                
            }
         }
    });
    
    app.controller('SrcRBCtrl', function($scope,$http, MyService) {

        $scope.srcnames = [
            { name: 'Hindi - Devanagari'      , code: 'hi' } ,  
            { name: 'English'                 , code: 'en' } ,
            { name: 'Hinglish'                , code: 'he' } ,
            { name: 'Benglish'                , code: 'be' } ,
            { name: 'Bengali'    , code: 'bn' } ,
            { name: 'Telugu'     , code: 'tg' } ,
            { name: 'Marathi'    , code: 'mr' } ,
            { name: 'Tamil'      , code: 'tm' } ,
            { name: 'Urdu'       , code: 'ur' } ,
            { name: 'Gujarati'   , code: 'gj' } ,
            { name: 'Kannada'    , code: 'kn' } ,
            { name: 'Malayalam'  , code: 'ml' } ,
            { name: 'Oriya'      , code: 'or' } ,
            { name: 'Gurmukhi'   , code: 'gr' } ,
        //  { name: 'Sinhalese'  , code: 'sh' } ,
            { name: 'Assamese'   , code: 'as' } 
        ];

        function srcdel(delkey){
            var len=$scope.srcnames.length;
            for(var i=0;i<len;i++){
                if($scope.srcnames[i].code==delkey) {
                    $scope.srcnames.splice(i,1);
                    break;
                }
            }
        }

        if(!IA_benglish) srcdel('be');
        if(!IA_hinglish) srcdel('he');
        if(!IA_poplogin && !IA_lrneng) srcdel('en');
        
        $scope.malekhmap = MyService.malekhmap;
        
        var src=storage.getItem("MaBhaSrTg").toLowerCase().substr(0,2);
        
        var hit=0;
        for(var i=0;i<$scope.srcnames.length;i++) {
          if($scope.srcnames[i].code==src) {
            hit=i;
            break;
          }
        }
       
       $scope.onesrc=$scope.srcnames[hit];
        
       $scope.updsrc = function(){
            $scope.malekhmap.map = $scope.onesrc.code+MyService.malekhmap.map.substr(2,2);
            MyService.update($scope.malekhmap.map);
        };
    });


    app.controller('TgtRBCtrl', function($scope,$http, MyService) {
        $scope.tgtnames = [
            { name: 'Hindi - Devanagari'      , code: 'hi' } ,  
            { name: 'English - Standard'      , code: 'en' } ,
            { name: 'English - Diacritics'    , code: 'ed' } ,
            { name: 'Bengali'    , code: 'bn' } ,
            { name: 'Telugu'     , code: 'tg' } ,
            { name: 'Marathi'    , code: 'mr' } ,
            { name: 'Tamil'      , code: 'tm' } ,
            { name: 'Urdu'       , code: 'ur' } ,
            { name: 'Gujarati'   , code: 'gj' } ,
            { name: 'Kannada'    , code: 'kn' } ,
            { name: 'Malayalam'  , code: 'ml' } ,
            { name: 'Oriya'      , code: 'or' } ,
            { name: 'Gurmukhi'   , code: 'gr' } ,
        //  { name: 'Sinhalese'  , code: 'sh' } ,
            { name: 'Assamese'   , code: 'as' }  
        ];
        
        $scope.malekhmap = MyService.malekhmap;
        
        var tgt=storage.getItem("MaBhaSrTg").toLowerCase().substr(2,2);
        
        var hit=1;
        for(var i=0;i<$scope.tgtnames.length;i++) {
          if($scope.tgtnames[i].code==tgt) {
            hit=i;
            break;
          }
        }
       
        $scope.onetgt=$scope.tgtnames[hit];
        
        $scope.updtgt = function(){
            $scope.malekhmap.map = MyService.malekhmap.map.substr(0,2)+$scope.onetgt.code;
            MyService.update($scope.malekhmap.map);
            
        };

    });

    app.controller('MapCtrl', function($scope,$http, myModal, MyService) {

        if(storage.getItem("MaBhaDaily")==undefined) {
           storage.setItem("MaBhaDaily","1999-01-01");
        }

        today = new Date();
        todaystr = today.toISOString().substr(0,10);
        if(storage.getItem("MaBhaDaily")!=todaystr){
           storage.setItem("MaBhaDaily",todaystr);
           this.showModal = myModal.activate;
           this.showModal();
        }

        today = new Date();
        todaystr = today.toISOString().substr(0,7);

        if(IA_poplogin) {
            if(storage.getItem("MaBhaTOD")!=todaystr) {
                //MyService.malekhmap.map="hien"; 
                storage.setItem("MaBhaLSTAT","Please Login!");
                storage.setItem("MaBhaNDays","-1");
                document.getElementById('popup').style.display='block';
            }
            document.getElementById('logOffApp').style.display='block';
            document.getElementById('logStatus').value=storage.getItem("MaBhaLSTAT");
            document.getElementById('logStatus2').value=storage.getItem("MaBhaLSTAT");
        }
        else {
           document.getElementById('popup').style.display='none'; 
           document.getElementById('logOffApp').style.display='none'; 
           storage.setItem("MaBhaTOD",todaystr);
           storage.setItem("MaBhaLSTAT","Validity 999 days");
        }

        String.prototype.capitalize = function() {
            return this.charAt(0).toUpperCase() + this.slice(1);
        }; 
        
//        $http.get("http://readmylanguage.com/assets/andver.txt?v="+(new Date().getTime().toString())).
//                success(function(data, status, headers, config) {
//                  // console.log(data);
//                  storage.setItem("NowVer",data.replace(/\s|\n|\r/g,''));
//                  // alert("Got Version " + storage.getItem("NowVer"));
//                }).
//                error(function(data, status, headers, config) {
//                  storage.setItem("NowVer",storage.getItem("CurVer"));
//                });
        
        $scope.malekhmap = MyService.malekhmap;
        $scope.maptext={showmap:'JBLN'};
        $scope.ShowMap = function() {
        
            // chrome.browserAction.setBadgeBackgroundColor({ color: [0, 0, 0, 255] });
            
            var MaBhaSrTg=$scope.malekhmap.map.substr(0,2).capitalize() + $scope.malekhmap.map.substr(2,2).capitalize();
            
            // chrome.browserAction.setBadgeText({text: (MaBhaSrTg.substr(0,2)==MaBhaSrTg.substr(2,2)? "OFF":MaBhaSrTg)});
            
            storage.setItem("MaBhaSrTg",MaBhaSrTg);
            
            if ($scope.malekhmap.map.substr(0, 2) == $scope.malekhmap.map.substr(2, 2)) {
                $scope.maptext.showmap = 'OFF! Inactive';
            }
            else {
                $scope.maptext.showmap = $scope.malekhmap.esr + ' => ' + $scope.malekhmap.etg;
                                 //        $scope.malekhmap.vsr + ' => ' + $scope.malekhmap.vtg;
            }
            return $scope.maptext.showmap;
        };
    });
    
    app.controller('URLsCtrl', function($scope,$http, MyService) {
      
        $scope.malekhmap = MyService.malekhmap;
        
        $scope.mybmks = sixbmks;
        $scope.mybmk=sixbmks[0];

        $scope.updurlbmk = function() {
           if($scope.mybmk.substr(0,4)!="book") 
             document.getElementById('inpURL').value=$scope.mybmk;
        };
 
        $scope.updbmks = function() { 
          if(storage.getItem("LastURL")==undefined)
            return;
          
          if(/readmylanguage.com\/readmylanguage\//i.test(storage.getItem("LastURL"))||
             /readmylanguage.com\/assets\//i.test(storage.getItem("LastURL"))||
             /translate\.google/i.test(storage.getItem("LastURL"))
             )
            return;


          if(storage.getItem("LastURL").trim()=="")
            return;
          

          var nowURL = storage.getItem("LastURL");
          
          for(var i=1;i<=6;i++) {
            onech=i.toString();
            if(nowURL.toLowerCase()==storage.getItem("bmk" + onech).toLowerCase()) {
              navigator.notification.alert(
                        'Book Mark already added',    // message
                        null,       // callback
                        "Duplicate!", // title
                        'OK'        // buttonName
                    );
               return;
            }
          }
          var onech="";
          var prvch="";
          for(var i=6;i>=2;i--) {
            onech=i.toString();
            prvch=(i-1).toString();
            storage.setItem("bmk" + onech,storage.getItem("bmk" + prvch)); 
          }
          storage.setItem("bmk1",nowURL);  
           
          sixinit();
          $scope.mybmks = sixbmks;
          $scope.mybmk=sixbmks[0];
          navigator.notification.alert(
                    'Book Mark added',    // message
                    null,       // callback
                    "Happy to Help!", // title
                    'OK'        // buttonName
                );
        };
        
    });
  
    


function showURL(theUrl) {

        today = new Date();
        todaystr = today.toISOString().substr(0,7);

        if(storage.getItem("MaBhaTOD")!=todaystr) { // !=
          navigator.notification.alert(
                    'Must Login to use',    // message
                    null,       // callback
                    "Close App and Retry", // title
                    'OK'        // buttonName
                );
          return;
        }
        
        // alert(theUrl);
        document.getElementById("inpURL").value=theUrl;
        
        if (myCodeInp == undefined || myCodeInp.length < 10000 || myCodeInp.indexOf("IA_SRTG") == -1) {
            myCodeInp = "var jncInit; (jncInit = function jncInit () {  return '0'; })()";
            alert("Network Init Fail - Stop App & try again");
            return;
        }
        
//        if(storage.getItem("NowVer") != storage.getItem("CurVer")){
//          alert("New Version " + storage.getItem("NowVer") + " available\nPlease Update this App\nTo Avail better Language Mappings etc.");
//          storage.setItem("NowVer",storage.getItem("CurVer"));
//        } 
        
        var win = window.open(theUrl, '_blank', 'location=yes', 'hidden=no');
        // var myCode=getAsset("js/transcc.js");
        // alert(storage.getItem("MaBhaSrTg"));
        // alert(storage.getItem("FontPX"));
        var suborno=storage.getItem("MaBhaSrTg").toLowerCase();

        //myCode=myCodeInp.replace("#srtg#",suborno); 
        
        win.addEventListener( "loadstart", function(event) {
            if(IA_platform=="AND")
              navigator.notification.activityStart('', 'Loading ...'); 
        });
        
        // myCode=myCode.replace("#fnsz#",storage.getItem("FontPX")); 
        // alert((myCode.length).toString() + " " + myCode.substr(-60));
        win.addEventListener( "loadstop", function(event) {
            if(IA_platform=="AND")
               navigator.notification.activityStop();

            if(!(/readmylanguage.com\/readmylanguage\//i.test(event.url)||
                /readmylanguage.com\/assets\//i.test(event.url)||
                /translate\.google/i.test(event.url)
                )) {
              storage.setItem("LastURL",event.url);
              if( prvUrl==event.url) {
                IA_addpage=false;
              } else{
                prvUrl=event.url;
                IA_addpage=true;
              }
            }
            document.getElementById("inpURL").value="";
            win.executeScript(
                { code: " var preInit; (preInit = function preInit () { " +
                        " var weblinks = document.getElementsByTagName('a'); " +
                        " for (var i=0; i<weblinks.length; i++) { " +
                        "   weblinks[i].setAttribute('target', '_self'); } " + 
                        " localStorage['IA_SRTG']='" + suborno+"'; return '0'; })()"},  
                function( values ) {
                    win.executeScript(
                        { code: myCodeInp },  
                        function( values ) {
                            if(IA_addpage) {
                              //alert( values[ 0 ] );
                              var noPage=1; 
                              var noConv=Number(values[0]); 

                              if(storage.getItem(suborno+"P")==undefined)
                                 storage.setItem(suborno+"P",noPage.toString());
                              else
                                 storage.setItem(suborno+"P",(Number(storage.getItem(suborno+"P"))+noPage).toString());

                              if(storage.getItem(suborno+"C")==undefined)
                                 storage.setItem(suborno+"C",noConv.toString());
                              else
                                 storage.setItem(suborno+"C",(Number(storage.getItem(suborno+"C"))+noConv).toString());
                              
                              flushStats();   
                            } 
                        }
                    );               
                }
            );
        });
        
        win.addEventListener( "loaderror", function(event) {
            if(IA_platform=="AND")
               navigator.notification.activityStop();

            storage.setItem("LastURL","");
            // NSURLErrorCancelled
            if(event.message.indexOf('NSURLErrorDomain error -999')>0)
              return;
              
            navigator.notification.alert(event.type + ' - ' + event.message);
        });
        
}

document.addEventListener('DOMContentLoaded', function () {
    document.getElementById('urlOpen').addEventListener('click', urlOpenHandler);
});

function urlOpenHandler(e) {
    var nowURL=document.getElementById("inpURL").value;
    if(nowURL.trim()=="")
      return;
    nowURL=nowURL.replace(/\s/g,'');
    if(nowURL.substr(0,4)!=='http') {
       nowURL='http://'+nowURL;
       document.getElementById("inpURL").value=nowURL;
    }
    showURL(nowURL);
}
    
    
document.addEventListener('DOMContentLoaded', function () {
    document.getElementById('showHelp').addEventListener('click', clickHandler);
});

function clickHandler(e) {
    var nowURL = "http://readmylanguage.com/assets/leapphelpv2.html";
    if(!IA_lrneng) 
       nowURL=nowURL.replace(/leapp/,"app");
    showURL(nowURL);
} 

document.addEventListener('DOMContentLoaded', function () {
    document.getElementById('readList').addEventListener('click', readHandler);
});

function readHandler(e) {
    var nowURL = "http://readmylanguage.com/readmylanguage/readinglist.php";
    showURL(nowURL);
}    
    
 
document.addEventListener('DOMContentLoaded', function () {
    document.getElementById('readmylanguage').addEventListener('click', myhrefHandler);
});

document.addEventListener('DOMContentLoaded', function () {
    document.getElementById('urltxt').addEventListener('click', myhrefHandler);
});

function myhrefHandler(e) {
    var nowURL = "http://readmylanguage.com/readmylanguage/index.php";
    showURL(nowURL);
}

document.addEventListener('DOMContentLoaded', function () {
    document.getElementById('feedbacktxt').addEventListener('click', feedbackHandler);
});

document.addEventListener('DOMContentLoaded', function () {
    document.getElementById('feedback').addEventListener('click', feedbackHandler);
});

function feedbackHandler(e) {
    var nowURL = "http://readmylanguage.com/readmylanguage/contact.php?PFM=AND";
    showURL(nowURL);
}
   
   
   
document.addEventListener('DOMContentLoaded', function () {
    document.getElementById('facebook').addEventListener('click', facebookHandler);
});

function facebookHandler(e) {
    var nowURL = "https://www.facebook.com/ReadMyLanguageIN";
    showURL(nowURL);
}
    
document.addEventListener('DOMContentLoaded', function () {
    document.getElementById('googleplus').addEventListener('click', googleplusHandler);
});

function googleplusHandler(e) {
    var nowURL = "https://plus.google.com/108080110685243058142/posts";
    showURL(nowURL);
}
    

document.addEventListener('DOMContentLoaded', function () {
    document.getElementById('twitter').addEventListener('click', twitterHandler);
});

function twitterHandler(e) {
    var nowURL = "https://twitter.com/readmylanguage";
    showURL(nowURL);
}
    

document.addEventListener('DOMContentLoaded', function () {
    document.getElementById('reload').addEventListener('click', reloadHandler);
});
 
function reloadHandler(e) {
    if(storage.getItem("LastURL")==undefined)
      return;
    if(storage.getItem("LastURL")=="")
      return;
    navigator.notification.confirm(storage.getItem("LastURL"), confirmCallback, 'Last seen URL','Visit,Skip')
}

function confirmCallback(numbutton) {
  switch(numbutton) {
    case 1: showURL(storage.getItem("LastURL"));
            break;
    default: return;
  }
}
    
function keyWasPressed(e) {
  var theEvent = e || window.event;
  var keyPressed = theEvent.keyCode || theEvent.which;
  if (keyPressed == 13) {
     urlOpenHandler(e); 
  }
  return true;
}
 
function flushStats() {

    if(storage.getItem("StartMaBha")==undefined)
      storage.setItem("StartMaBha","true");
    
    if(storage.getItem("StartMaBha")=="false"){
      nowTime=Date.now();
      if(((nowTime-prvTime)/(60*1000))>12)   // > 12 minutes
        storage.setItem("StartMaBha","true");
    }
    
    if(storage.getItem("StartMaBha")=="true"){
      storage.setItem("StartMaBha","false");
      prvTime=Date.now();
      
      var elang = {
          'hi' : 'Hindi' ,
          'mr' : 'Marathi' ,
          'bn' : 'Bengali' ,
          'as' : 'Assamese',
          'gr' : 'Gurmukhi' ,
          'gj' : 'Gujarati' ,
          'or' : 'Oriya' ,
          'tm' : 'Tamil' ,
          'tg' : 'Telugu' ,
          'kn' : 'Kannada' ,
          'ml' : 'Malayalam' ,
          'sh' : 'Sinhala' ,
          'ur' : 'Urdu' ,
          'en' : 'EnglishS',
          'ed' : 'EnglishD',
          'he' : 'Hinglish',
          'be' : 'Benglish'
      };
      
      var src="";
      var tgt="";
  
      for(src in elang) {
         for(tgt in elang) {
           if(storage.getItem(src+tgt+"C")) {
             if(src!=tgt) {
               var url = "http://readmylanguage.com:88/analytics?PFM=" + IA_platform +
                          '&STD=' +storage.getItem("BgStudId") +
                          '&SRC=' + src + 
                          '&TGT=' + tgt + 
                          '&PAGES=' + storage.getItem(src+tgt+"P") +
                          '&FLIPS=' + storage.getItem(src+tgt+"C");
               // console.log(url);  
               try {
                  var xhr = new XMLHttpRequest();
        
                  xhr.open("GET", url, true);
                  
                  // xhr.onreadystatechange = function() {
                  // }
                
                  xhr.send();
                } catch (ex) {
                   //console.log(ex);
                }
             }
           }
        }
      } 

      for(src in elang) {
         for(tgt in elang) {
           if(storage.getItem(src+tgt+"C")) {
              storage.removeItem(src+tgt+"P") ; 
              storage.removeItem(src+tgt+"C") ;     
           }
        }
      }
      
    }
}    


    document.addEventListener('DOMContentLoaded', function () {
        document.getElementById('logStatus').value=storage.getItem("MaBhaLSTAT");

        document.getElementById('logIn').addEventListener('click', loginHandler);

        document.getElementById('close').addEventListener('click', closeHandler);

        document.getElementById('accessKey').addEventListener('userLogin', processStdChk);
    });

    function closeHandler(e) {
        if(storage.getItem("MaBhaNDays").charAt(0)=="-")
          document.getElementById('popup').style.display='block';
        else
          document.getElementById('popup').style.display='none';
    }

    function loginHandler(e) {
        storage.setItem("MaBhaTOD","1999-01");

        var studentId=document.getElementById('studentId').value.trim();
        var accessKey=document.getElementById('accessKey').value.trim();

        if(studentId==""||accessKey=="") {
            storage.setItem("MaBhaLSTAT","Enter Student Id and Access Key");
            document.getElementById('logStatus').value=storage.getItem("MaBhaLSTAT");
            return;
        }

        dostdchk(studentId,accessKey);

    }

    function processStdChk (e) {

      var msg=e.detail.msg;

      storage.setItem("MaBhaNDays",msg);

      if(msg=="-999"){
        storage.setItem("MaBhaLSTAT","Student Id Invalid");
        document.getElementById('logStatus').value=storage.getItem("MaBhaLSTAT");
        return;
      }
      if(msg=="-888"){
        storage.setItem("MaBhaLSTAT","Access Key Invalid");
        document.getElementById('logStatus').value=storage.getItem("MaBhaLSTAT");
        return;
      }
      if(msg=="-777"){
        storage.setItem("MaBhaLSTAT","Please Register");
        document.getElementById('logStatus').value=storage.getItem("MaBhaLSTAT");
        return;
      }
      if(Number(msg)<0){
        storage.setItem("MaBhaLSTAT","Expired for days "+msg);
        document.getElementById('logStatus').value=storage.getItem("MaBhaLSTAT");
        return;
      }
      if(Number(msg)>=0){
        today = new Date();
        todaystr = today.toISOString().substr(0,7);
        storage.setItem("MaBhaTOD",todaystr);
        storage.setItem("MaBhaLSTAT","Validity days "+msg);
        document.getElementById('logStatus').value=storage.getItem("MaBhaLSTAT");
        document.getElementById('logStatus2').value=storage.getItem("MaBhaLSTAT");
        document.getElementById('popup').style.display='none';
        document.getElementById('logOffApp').style.display='block'; 
        return;
      }
    };
    
function dostdchk(studentId,accessKey) {
    storage.setItem("BgStudId","Anon");

    var url = "http://readmylanguage.com:88/stdchk?ID=" + studentId + 
                          '&AK=' + accessKey;
    var xhr = new XMLHttpRequest();
    xhr.ontimeout = function () {
      var myEvent = new CustomEvent("userLogin", {
        detail: { msg : "-999" }
      });

      document.getElementById('accessKey').dispatchEvent(myEvent); 
      return;
    };

    xhr.onerror = function (e) {
      var myEvent = new CustomEvent("userLogin", {
        detail: { msg : "-999" }
      });

      document.getElementById('accessKey').dispatchEvent(myEvent); 
      return;
    }; 

    xhr.onreadystatechange = function()
    {
        if (xhr.readyState == 4 && (xhr.status == 200 || xhr.status == 0))
        {
            if(Number(xhr.responseText)>=0)
              storage.setItem("BgStudId",studentId);

            var myEvent = new CustomEvent("userLogin", {
              detail:  { msg : xhr.responseText }
            });

            document.getElementById('accessKey').dispatchEvent(myEvent); 
            return;
        }
    }; 

    xhr.open('GET', url);
    xhr.responseType = 'text';
    xhr.timeout = 20000; // 20 seconds
    xhr.send();
        
  }

// let's make a modal called `myModal`
app.factory('myModal', function (btfModal) {
  return btfModal({
    controller: 'MyModalCtrl',
    controllerAs: 'modal',
    templateUrl: 'modal.html'
  });
});

// typically you'll inject the modal service into its own
// controller so that the modal can close itself
app.controller('MyModalCtrl', function ($scope, $timeout, myModal) {
  
  var ctrl = this,
      timeoutId;
  
  ctrl.tickCount = 30;
  
  ctrl.closeMe = function () {
    cancelTick();
    myModal.deactivate();
  };
  
  function tick() {
    timeoutId = $timeout(function() {
      ctrl.tickCount -= 1;
      if (ctrl.tickCount <= 0) {
        ctrl.closeMe();
      } else {
        tick();
      }
    }, 1000);
  }
  
  function cancelTick() {
    $timeout.cancel(timeoutId);
  }

  $scope.$on('$destroy', cancelTick);

  tick();
});

